/*
 * This file is part of vomitpage.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

int cmp(const char *s) {
  int i;
  if ( !s ) return -1;
  for( i = 0 ; i < WIN_LEN && s[0] &&
               (s[0] == win[i] || win[i] == 0) ; i++,s++ );
  return (int)s[0];
}

char fgetc2(void) {
  char c;
  c = fgetc(in);
  if ( c == EOF ) {
    last_char = 0;
    return 0;
  }
  if ( c == '\n' ) lineno++;
  last_char = c;
  return c;
}

void shift_for_blockcode(int s,int ign) {
  int i,c;
  if ( s > 0 && s <= WIN_LEN ) {
    for( i = 0 ; i + s < WIN_LEN ; i++ ) {
      win[i] = win[i + s];
      indent[i] = indent[i + s];
    }
  }
  for( i = WIN_LEN - s ; i < WIN_LEN ; i++ ) {
    if ( last_char == '\n' ) {
      int j;
      for( j = 0 ; j < ign ; j++ ) {
        c = fgetc2();
        if ( c == '\t' ) {
          warning("I just read a tab, I count it as 8 spaces");
          j += 7;
          continue;
        }
        if ( c == '\n' ) goto shift_for_blockcode_next;
        if ( c != ' ' ) warning("it should be a space");
      }
    }
    c = fgetc2();
shift_for_blockcode_next:;
    win[i] = c;
  }
}

void shift(int s) {
  int i,c;
  if ( s > 0 && s <= WIN_LEN ) {
    for( i = 0 ; i + s < WIN_LEN ; i++ ) {
      win[i] = win[i + s];
      indent[i] = indent[i + s];
    }
  }
  for( i = WIN_LEN - s ; i < WIN_LEN ; i++ ) {
    if ( last_char == '\n' ) {
      int j;
      for( j = 0 ; ; j++ ) {
        if ( j > TABSTOP * MAX_DEPTH ) error("too deeply nested");
        c = fgetc2();
        if ( c == '\t' ) {
          warning("I just read a tab, I count it as 8 spaces");
          j += 7;
          continue;
        }
        if ( c != ' ' ) {
          win[i] = c;
          indent[i] = j;
          break;
        }
      }
    }
    else {
      c = fgetc2();
      win[i] = c;
    }
  }
}

