" This file is part of vomitpage.
" Copyright (C) 2012  Guillaume Quintin
" 
" This program is free software; you can redistribute it and/or modify
" it under the terms of the GNU General Public License as published by
" the Free Software Foundation; either version 2 of the License, or
" (at your option) any later version.
" 
" This program is distributed in the hope that it will be useful,
" but WITHOUT ANY WARRANTY; without even the implied warranty of
" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
" GNU General Public License for more details.
" 
" You should have received a copy of the GNU General Public License along
" with this program; if not, write to the Free Software Foundation, Inc.,
" 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

" Syntax highlighting for vomitpage (.man) files
" http://coincoin169.ath.cx/


if exists("b:current_syntax")
  finish
endif
let b:current_syntax = "vomitpage"


" Inside paragraphs

sy match vomitpage_escaped "\\." contained
sy region vomitpage_em
   \ start="\*"
   \ end="\*"
   \ contained contains=vomitpage_escaped
sy region vomitpage_inline_code
   \ start="`"
   \ end="`"
   \ contained contains=vomitpage_escaped

hi def link vomitpage_escaped     Constant
hi def link vomitpage_em          Underlined
hi def link vomitpage_inline_code Statement


" Paragraphs

sy region vomitpage_verbatim
   \ start="``\n"
   \ end="\n\s*``"
sy region vomitpage_comment
   \ start="##\n"
   \ end="\n\s*##"
sy region vomitpage_title2
   \ start="=="
   \ end="=="
   \ contains=vomitpage_escaped,vomitpage_em,vomitpage_inline_code
sy region vomitpage_title3
   \ start="==="
   \ end="==="
   \ contains=vomitpage_escaped,vomitpage_em,vomitpage_inline_code
sy region vomitpage_normal
   \ start="\([^=`#]\|=[^=]\|`[^`]\|#[^#]\)"
   \ end="\n\s*\n"
   \ contains=vomitpage_escaped,vomitpage_em,vomitpage_inline_code

hi def link vomitpage_comment Comment
hi def link vomitpage_title2  Identifier
hi def link vomitpage_title3  Identifier

